from apgl.graph import *
from apgl.io.PajekWriter import PajekWriter
import unittest
import cProfile
import pstats


profileFileName = "profile.cprof"

p = 0.5
k = 15
edgeWeight = 1

numVertices = 200
numFeatures = 5

vList = VertexList(numVertices, numFeatures)
sGraph = SparseGraph(vList)
swg = SmallWorldGenerator(sGraph)

cProfile.runctx('swg.generateGraph(p, k, edgeWeight)', globals(), locals(), profileFileName)
stats = pstats.Stats(profileFileName)
stats.strip_dirs().sort_stats("cumulative").print_stats(20)