"""
A script to compute some statistics relating to the contact rates of HIV infected
individuals.
"""
import logging
import sys
import numpy
import mlpy 
from apgl.util import *
from apgl.graph import *
from apgl.viroscopy.HIVGraphReader import HIVGraphReader

logging.basicConfig(stream=sys.stdout, level=logging.INFO)

hivReader = HIVGraphReader()
graph = hivReader.readHIVGraph()
fInds = hivReader.getFeatureIndices()

#The set of edges indexed by zeros is the contact graph
#The ones indexed by 1 is the infection graph
edgeTypeIndex1 = 0
edgeTypeIndex2 = 1
sGraphContact = graph.getSparseGraph(edgeTypeIndex1)
sGraphInfect = graph.getSparseGraph(edgeTypeIndex2)
sGraphContact.add(sGraphInfect)

sGraph = sGraphContact

numExamples = 100
X = sGraph.vertexLabelPairs(sGraph.getAllEdges())
X = X[numpy.random.permutation(X.shape[0])[0:numExamples], :]

print("Shape of examples " + str(X.shape))

dtw = mlpy.Dtw(onlydist=True)
km = mlpy.Kmedoids(k=3, dist=dtw)

#Really slow even with 500 examples 
m,n, co, cl = km.compute(X)

#Can try EM 