

graphStats = GraphStatistics()
statsArray = graphStats.sequenceScalarStats(graph, removedIndices, True)

removedSubgraph = graph.subgraph(removedIndices[-1])
statsDict = graphStats.vectorStatistics(removedSubgraph)


#Let's plot the statistics
plotInd = 1
plt.figure(plotInd)
plt.plot(times, statsArray[:, graphStats.maxComponentSizeIndex])
plt.xlabel("Time (days)")
plt.ylabel("Max Component Size")
plotInd += 1

plt.figure(plotInd)
plt.plot(times, statsArray[:, graphStats.numComponentsIndex])
plt.xlabel("Time (days)")
plt.ylabel("Number of components")
plotInd += 1

plt.figure(plotInd)
plt.plot(times, statsArray[:, graphStats.meanComponentSizeIndex])
plt.xlabel("Time (days)")
plt.ylabel("Mean Component Sizes")
plotInd += 1

plt.figure(plotInd)
plt.plot(times, statsArray[:, graphStats.effectiveDiameterIndex])
plt.xlabel("Time (days)")
plt.ylabel("Max Component Effective Diameter")
plotInd += 1

degreeDist = statsDict["outDegreeDist"]

plt.figure(plotInd)
plt.plot(numpy.arange(degreeDist.shape[0]), degreeDist/float(numpy.sum(degreeDist)))
plt.xlabel("Degree")
plt.ylabel("Probability")
plotInd += 1


#Make sure we don't include 0 in the array
vertexIndex = numpy.argmax(statsArray[:, graphStats.numVerticesIndex] > 0)
edgeIndex = numpy.argmax(statsArray[:, graphStats.numEdgesIndex] > 0)
minIndex = numpy.maximum(vertexIndex, edgeIndex)

plt.figure(plotInd)
plt.plot(numpy.log(statsArray[minIndex:, graphStats.numVerticesIndex]), numpy.log(statsArray[minIndex:, graphStats.numEdgesIndex]))
plt.xlabel("log(numVertices)")
plt.ylabel("log(numEdges)")
plotInd += 1


plt.figure(plotInd)
plt.plot(times, statsArray[:, graphStats.meanDegreeIndex])
plt.xlabel("Time (days)")
plt.ylabel("meanDegrees")
plotInd += 1

plt.show()
