

import unittest
from apgl.viroscopy.model.HIVGraph import HIVGraph
from apgl.viroscopy.model.HIVIndividual import HIVIndividual

class  HIVIndividualTest(unittest.TestCase):
    def setup(self):
        pass

    def testContructor(self):
        numVertices = 10
        graph = HIVGraph(numVertices)

        ind = HIVIndividual()

        for i in range(numVertices):
            self.assertTrue(type(graph.getVertex(i)) == HIVIndividual)

        self.assertTrue(graph.isUndirected() == True)

    def testGetSusceptibleSet(self):
        numVertices = 10
        graph = HIVGraph(numVertices)

        self.assertTrue(graph.getSusceptibleSet() == set(range(numVertices)))

        for i in range(9):
            graph.getVertex(i).setInfected(0.0)

        self.assertTrue(graph.getSusceptibleSet() == set([9]))

    def testGetInfectedSet(self):
        numVertices = 10
        graph = HIVGraph(numVertices)

        self.assertTrue(graph.getInfectedSet() == set([]))

        graph.getVertex(1).setInfected(0.0)
        graph.getVertex(3).setInfected(0.0)
        graph.getVertex(7).setInfected(0.0)

        self.assertTrue(graph.getInfectedSet() == set([1, 3, 7]))

    def testGetRemovedSet(self):
        numVertices = 10
        graph = HIVGraph(numVertices)

        self.assertTrue(graph.getRemovedSet() == set([]))

        graph.getVertex(1).setInfected(0.0)
        graph.getVertex(2).setInfected(0.0)
        graph.getVertex(7).setInfected(0.0)

        graph.getVertex(1).setDetected(0.0)
        graph.getVertex(2).setDetected(0.0)
        graph.getVertex(7).setDetected(0.0)

        self.assertTrue(graph.getRemovedSet() == set([1, 2, 7]))

if __name__ == '__main__':
    unittest.main()

