
import numpy 
import unittest
from apgl.viroscopy.model.HIVRates import HIVRates
from apgl.viroscopy.model.HIVGraph import HIVGraph

class  HIVRateFuncsTestCase(unittest.TestCase):
    def setUp(self):
        numpy.set_printoptions(suppress=True)
        numpy.random.seed(21)

    def testContactRate(self):
        undirected = True 
        numVertices = 10
        graph = HIVGraph(numVertices, undirected)

        for i in range(numVertices):
            print(graph.getVertex(i))

        vertex1Ind = 0
        susceptibleList = range(1, numVertices)
        t = 0.2

        rates = HIVRates(graph)
        self.assertEquals(rates.contactRate(vertex1Ind, [], t).shape[0], 0)

        #Now we have that 0 had contact with another
        #graph.addEdge(0, 3, 0.1)
        #graph.addEdge(0, 9, 0.1)
        rates.contactEvent(0, 3, 0.1)
        rates.contactEvent(0, 9, 0.1)

        #Seems to work 
        print(rates.contactRate(vertex1Ind, susceptibleList, t))

        for i in range(numVertices): 
            print(rates.contactTimesList[i])

        self.assertTrue((rates.degreeSequence == numpy.array([2,0,0,1,0,0,0,0,0, 1])).all())



if __name__ == '__main__':
    unittest.main()

